libmemcached-1.0: fix subscripting on empty vector
[awesomized/libmemcached] / bootstrap.sh
index fdc43f999d0024fc2b576ddf4a672631e84c8040..25cc175a1717d53553bfc5f86064456933b2bc6c 100755 (executable)
 #   LIBTOOLIZE
 #   MAKE
 #   PREFIX
-#   TESTS_ENVIRONMENT
+#   LOG_COMPILER
 #   VERBOSE
 #   WARNINGS
 #
 
+use_banner ()
+{
+  echo "#####################################################################################"
+  echo "#"
+  echo "#"
+  echo "#"
+  echo "#    TARGET:$1"
+  echo "#"
+  echo "#"
+  echo "#"
+  echo "#####################################################################################"
+}
+
 command_not_found_handle ()
 {
   warn "$@: command not found"
@@ -60,27 +73,27 @@ command_not_found_handle ()
   return 127
 }
 
-function error ()
+error ()
 { 
   echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
 }
 
-function die ()
+die ()
 { 
   echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
   exit 1; 
 }
 
-function warn ()
+warn ()
 { 
   echo "$BASH_SOURCE:$BASH_LINENO: $@"
   #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
 }
 
-function nassert ()
+nassert ()
 {
   local param_name=\$"$1"
-  local param_value=`eval "expr \"$param_name\" "`
+  local param_value="$(eval "expr \"$param_name\" ")"
 
   if [ -n "$param_value" ]; then
     echo "$bash_source:$bash_lineno: assert($param_name) had value of "$param_value"" >&2
@@ -88,10 +101,10 @@ function nassert ()
   fi
 }
 
-function assert ()
+assert ()
 {
   local param_name=\$"$1"
-  local param_value=`eval "expr \"$param_name\" "`
+  local param_value="$(eval "expr \"$param_name\" ")"
 
   if [ -z "$param_value" ]; then
     echo "$bash_source:$bash_lineno: assert($param_name)" >&2
@@ -99,7 +112,7 @@ function assert ()
   fi
 }
 
-function assert_file ()
+assert_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -107,7 +120,7 @@ function assert_file ()
   fi
 }
 
-function assert_no_file ()
+assert_no_file ()
 {
   if [ -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
@@ -115,7 +128,7 @@ function assert_no_file ()
   fi
 }
 
-function assert_no_directory ()
+assert_no_directory ()
 {
   if [ -d "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
@@ -123,7 +136,7 @@ function assert_no_directory ()
   fi
 }
 
-function assert_exec_file ()
+assert_exec_file ()
 {
   if [ ! -f "$1" ]; then
     echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
@@ -136,25 +149,26 @@ function assert_exec_file ()
   fi
 }
 
-function command_exists ()
+command_exists ()
 {
   type "$1" &> /dev/null ;
 }
 
-function rebuild_host_os ()
+rebuild_host_os ()
 {
   HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
   if [ -z "$1" ]; then
-    if $VERBOSE; then
+    if $verbose; then
       echo "HOST_OS=$HOST_OS"
     fi
   fi
 }
 
-#  Valid values are: darwin,fedora,rhel,ubuntu
-function set_VENDOR_DISTRIBUTION ()
+# Validate the distribution name, or toss an erro
+#  values: darwin,fedora,rhel,ubuntu,debian,opensuse
+set_VENDOR_DISTRIBUTION ()
 {
-  local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
+  local dist="$(echo "$1" | tr '[:upper:]' '[:lower:]')"
   case "$dist" in
     darwin)
       VENDOR_DISTRIBUTION='darwin'
@@ -165,51 +179,109 @@ function set_VENDOR_DISTRIBUTION ()
     rhel)
       VENDOR_DISTRIBUTION='rhel'
       ;;
+    debian)
+      VENDOR_DISTRIBUTION='debian'
+      ;;
     ubuntu)
       VENDOR_DISTRIBUTION='ubuntu'
       ;;
+    suse)
+      VENDOR_DISTRIBUTION='opensuse'
+      ;;
     opensuse)
       VENDOR_DISTRIBUTION='opensuse'
       ;;
+    arch)
+      VENDOR_DISTRIBUTION='arch'
+      ;;
     *)
       die "attempt to set an invalid VENDOR_DISTRIBUTION=$dist"
       ;;
   esac
 }
 
-function set_VENDOR_RELEASE ()
+# Validate a Vendor's release name/number 
+set_VENDOR_RELEASE ()
 {
-  local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
-  case "$VENDOR_DISTRIBUTION" in
+  local release="$(echo "$1" | tr '[:upper:]' '[:lower:]')"
+
+  if $verbose; then 
+    echo "VENDOR_DISTRIBUTION:$VENDOR_DISTRIBUTION"
+    echo "VENDOR_RELEASE:$release"
+  fi
+
+  case $VENDOR_DISTRIBUTION in
     darwin)
-      VENDOR_RELEASE='mountain'
+      case $release in
+        10.6*)
+          VENDOR_RELEASE='snow_leopard'
+          ;;
+        10.7*)
+          VENDOR_RELEASE='mountain'
+          ;;
+        mountain)
+          VENDOR_RELEASE='mountain'
+          ;;
+        10.8.*)
+          echo "mountain_lion"
+          VENDOR_RELEASE='mountain_lion'
+          ;;
+        10.9)
+          echo "mavericks"
+          VENDOR_RELEASE='mavericks'
+          ;;
+        10.9.*)
+          echo "mavericks"
+          VENDOR_RELEASE='mavericks'
+          ;;
+        *)
+          echo $release
+          VENDOR_RELEASE='unknown'
+          ;;
+      esac
       ;;
     fedora)
       VENDOR_RELEASE="$release"
+      if [[ "x$VENDOR_RELEASE" == '18' ]]; then
+        VENDOR_RELEASE='sphericalcow'
+      fi
       ;;
     rhel)
       VENDOR_RELEASE="$release"
       ;;
+    debian)
+      VENDOR_RELEASE="$release"
+      ;;
     ubuntu)
       VENDOR_RELEASE="$release"
+      if [[ "x$VENDOR_RELEASE" == 'x12.04' ]]; then
+        VENDOR_RELEASE="precise"
+      elif [[ "x$VENDOR_RELEASE" == 'x12.10' ]]; then
+        VENDOR_RELEASE="quantal"
+      elif [[ "x$VENDOR_RELEASE" == 'x13.04' ]]; then
+        VENDOR_RELEASE="raring"
+      fi
       ;;
     opensuse)
       VENDOR_RELEASE="$release"
       ;;
+    arch)
+      VENDOR_RELEASE=""
+      ;;
     unknown)
       die "attempt to set VENDOR_RELEASE without setting VENDOR_DISTRIBUTION"
       ;;
     *)
-      die "attempt to set with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
+      die "attempt to set VENDOR_RELEASE with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
       ;;
   esac
 }
 
 
-#  Valid values are: apple, redhat, centos, canonical
-function set_VENDOR ()
+#  Valid values are: apple, redhat, centos, canonical, oracle, suse
+set_VENDOR ()
 {
-  local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
+  local vendor="$(echo "$1" | tr '[:upper:]' '[:lower:]')"
 
   case $vendor in
     apple)
@@ -218,67 +290,113 @@ function set_VENDOR ()
     redhat)
       VENDOR='redhat'
       ;;
+    fedora)
+      VENDOR='redhat'
+      ;;
+    redhat-release-server-*)
+      VENDOR='redhat'
+      ;;
+    enterprise-release-*)
+      VENDOR='oracle'
+      ;;
     centos)
       VENDOR='centos'
       ;;
     canonical)
       VENDOR='canonical'
       ;;
+    ubuntu)
+      VENDOR='canonical'
+      ;;
+    debian)
+      VENDOR='debian'
+      ;;
+    opensuse)
+      VENDOR='suse'
+      ;;
     suse)
       VENDOR='suse'
       ;;
+    arch)
+      VENDOR='arch'
+      ;;
     *)
-      die "An attempt was made to set an invalid VENDOR=$_vendor"
+      die "An attempt was made to set an invalid VENDOR=$vendor"
+      ;;
+  esac
+
+  set_VENDOR_DISTRIBUTION "$2"
+  set_VENDOR_RELEASE "$3"
+
+  # Set which vendor/versions we trust for autoreconf
+  case $VENDOR_DISTRIBUTION in
+    fedora)
+      if [[ "x$VENDOR_RELEASE" == 'x18' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'xsphericalcow' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'x19' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      fi
+      ;;
+    canonical)
+      if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      elif [[ "x$VENDOR_RELEASE" == 'xquantal' ]]; then
+        AUTORECONF_REBUILD_HOST=true
+      fi
       ;;
   esac
 
-  set_VENDOR_DISTRIBUTION $2
-  set_VENDOR_RELEASE $3
 }
 
-function determine_target_platform ()
+determine_target_platform ()
 {
-  UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
-  UNAME_KERNEL=`(uname -s) 2>/dev/null`  || UNAME_SYSTEM=unknown
-  UNAME_KERNEL_RELEASE=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE=unknown
+  UNAME_MACHINE_ARCH="$(uname -m 2>/dev/null)" || UNAME_MACHINE_ARCH=unknown
+  UNAME_KERNEL="$(uname -s 2>/dev/null)"  || UNAME_SYSTEM=unknown
+  UNAME_KERNEL_RELEASE="$(uname -r 2>/dev/null)" || UNAME_KERNEL_RELEASE=unknown
 
-  if [[ $(uname) == 'Darwin' ]]; then
+  if [[ -x '/usr/bin/sw_vers' ]]; then 
+    local _VERSION="$(/usr/bin/sw_vers -productVersion)"
+    set_VENDOR 'apple' 'darwin' $_VERSION
+  elif [[ $(uname) == 'Darwin' ]]; then
     set_VENDOR 'apple' 'darwin' 'mountain'
   elif [[ -f '/etc/fedora-release' ]]; then 
-    local fedora_version=`cat /etc/fedora-release | awk ' { print $3 } '`
+    local fedora_version="$(awk ' { print $3 } ' < /etc/fedora-release)"
     set_VENDOR 'redhat' 'fedora' $fedora_version
-    if [[ "x$VENDOR_RELEASE" == 'x17' ]]; then
-      AUTORECONF_REBUILD_HOST=true
-    fi
   elif [[ -f '/etc/centos-release' ]]; then
-    local centos_version=`cat /etc/centos-release | awk ' { print $7 } '`
+    local centos_version="$(awk ' { print $7 } ' < /etc/centos-release)"
     set_VENDOR 'centos' 'rhel' $centos_version
   elif [[ -f '/etc/SuSE-release' ]]; then
-    local suse_distribution=`head -1 /etc/SuSE-release | awk ' { print $1 } '`
-    local suse_version=`head -1 /etc/SuSE-release | awk ' { print $2 } '`
+    local suse_distribution="$(head -1 /etc/SuSE-release | awk ' { print $1 } ')"
+    local suse_version="$(head -1 /etc/SuSE-release | awk ' { print $2 } ')"
     set_VENDOR 'suse' $suse_distribution $suse_version
   elif [[ -f '/etc/redhat-release' ]]; then
-    local rhel_version=`cat /etc/redhat-release | awk ' { print $7 } '`
-    set_VENDOR 'redhat' 'rhel' $rhel_version
+    local rhel_version="$(awk ' { print $7 } ' < /etc/redhat-release)"
+    local _vendor="$(rpm -qf /etc/redhat-release)"
+    set_VENDOR $_vendor 'rhel' $rhel_version
+  elif [[ -f '/etc/os-release' ]]; then 
+    source '/etc/os-release'
+    set_VENDOR $ID $ID $VERSION_ID
+  elif [[ -x '/usr/bin/lsb_release' ]]; then 
+    local _ID="$(/usr/bin/lsb_release -s -i)"
+    local _VERSION="$(/usr/bin/lsb_release -s -r)"
+    set_VENDOR $_ID $_ID $_VERSION
   elif [[ -f '/etc/lsb-release' ]]; then 
-    local debian_DISTRIB_ID=`cat /etc/lsb-release | grep DISTRIB_ID | awk -F= ' { print $2 } '`
-    local debian_version=`cat /etc/lsb-release | grep DISTRIB_CODENAME | awk -F= ' { print $2 } '`
-    set_VENDOR 'canonical' $debian_DISTRIB_ID $debian_version
-    if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
-      AUTORECONF_REBUILD_HOST=true
-    fi
+    source '/etc/lsb-release'
+    set_VENDOR 'canonical' $DISTRIB_ID $DISTRIB_CODENAME
   fi
 
   rebuild_host_os
 }
 
-function run_configure ()
+run_configure ()
 {
   # We will run autoreconf if we are required
   run_autoreconf_if_required
 
   # We always begin at the root of our build
-  if [ ! popd ]; then
+  if [ ! $? ]; then
     die "Programmer error, we entered run_configure with a stacked directory"
   fi
 
@@ -290,48 +408,48 @@ function run_configure ()
   if [[ -n "$BUILD_DIR" ]]; then
     rm -r -f $BUILD_DIR
     mkdir -p $BUILD_DIR
-    safe_pushd $BUILD_DIR
   fi
 
   # Arguments for configure
-  local BUILD_CONFIGURE_ARG= 
+  local BUILD_CONFIGURE_ARG='' 
 
-  # Set ENV DEBUG in order to enable debugging
-  if $DEBUG; then 
-    BUILD_CONFIGURE_ARG='--enable-debug'
+  # If debug is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
+  # Set ENV ASSERT in order to enable assert.
+  # If we are doing a valgrind run, we always compile with assert disabled
+  if $valgrind_run; then
+    BUILD_CONFIGURE_ARG="--enable-assert=no $BUILD_CONFIGURE_ARG"
+  else
+    if $debug; then 
+      BUILD_CONFIGURE_ARG="--enable-debug --enable-assert $BUILD_CONFIGURE_ARG"
+    elif [[ -n "$VCS_CHECKOUT" ]]; then
+      BUILD_CONFIGURE_ARG="--enable-assert $BUILD_CONFIGURE_ARG"
+    fi
   fi
 
-  # Set ENV ASSERT in order to enable assert
-  if [[ -n "$ASSERT" ]]; then 
-    local ASSERT_ARG=
-    ASSERT_ARG='--enable-assert'
-    BUILD_CONFIGURE_ARG="$ASSERT_ARG $BUILD_CONFIGURE_ARG"
+  if [[ -n "$CONFIGURE_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG="$CONFIGURE_ARG $BUILD_CONFIGURE_ARG"
   fi
 
-  if [[ -n "$CONFIGURE_ARG" ]]; then 
-    BUILD_CONFIGURE_ARG= "$BUILD_CONFIGURE_ARG $CONFIGURE_ARG"
+  if [[ -n "$PREFIX_ARG" ]]; then 
+    BUILD_CONFIGURE_ARG="$PREFIX_ARG $BUILD_CONFIGURE_ARG"
   fi
 
   ret=1;
   # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
   case $HOST_OS in
-    *-darwin-*)
-      CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
-      ret=$?
-      ;;
     rhel-5*)
       command_exists 'gcc44' || die "Could not locate gcc44"
-      CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+      run CC=gcc44 CXX=gcc44 $top_srcdir/configure "$BUILD_CONFIGURE_ARG" || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
       ret=$?
       ;;
     *)
-      $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG
+      run $CONFIGURE "$BUILD_CONFIGURE_ARG"
       ret=$?
       ;;
   esac
 
   if [ $ret -ne 0 ]; then
-    die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+    die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
   fi
 
   if [ ! -f 'Makefile' ]; then
@@ -339,25 +457,27 @@ function run_configure ()
   fi
 }
 
-function setup_gdb_command () {
+setup_gdb_command ()
+{
   GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
-  echo 'set logging overwrite on' > $GDB_TMPFILE
-  echo 'set logging on' >> $GDB_TMPFILE
-  echo 'set environment LIBTEST_IN_GDB=1' >> $GDB_TMPFILE
-  echo 'run' >> $GDB_TMPFILE
-  echo 'thread apply all bt' >> $GDB_TMPFILE
-  echo 'quit' >> $GDB_TMPFILE
+  echo 'set logging overwrite on' > "$GDB_TMPFILE"
+  echo 'set logging on' >> "$GDB_TMPFILE"
+  echo 'set environment LIBTEST_IN_GDB=1' >> "$GDB_TMPFILE"
+  echo 'run' >> "$GDB_TMPFILE"
+  echo 'thread apply all bt' >> "$GDB_TMPFILE"
+  echo 'quit' >> "$GDB_TMPFILE"
   GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
 }
 
-function setup_valgrind_command () {
-  VALGRIND_PROGRAM=`type -p valgrind`
+setup_valgrind_command ()
+{
+  VALGRIND_PROGRAM="$(type -p valgrind)"
   if [[ -n "$VALGRIND_PROGRAM" ]]; then
-    VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
+    VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --malloc-fill=A5 --free-fill=DE --xml=yes --xml-file=\"valgrind-%p.xml\""
   fi
 }
 
-function save_BUILD ()
+save_BUILD ()
 {
   if [[ -n "$OLD_CONFIGURE" ]]; then
     die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
@@ -367,12 +487,16 @@ function save_BUILD ()
     die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
   fi
 
+  if [[ -n "$OLD_PREFIX" ]]; then
+    die "OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
+  fi
+
   if [[ -n "$OLD_MAKE" ]]; then
     die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
   fi
 
-  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
+  if [[ -n "$OLD_LOG_COMPILER" ]]; then
+    die "OLD_LOG_COMPILER($OLD_LOG_COMPILER) was set on push, programmer error!"
   fi
 
   if [[ -n "$CONFIGURE" ]]; then
@@ -387,12 +511,12 @@ function save_BUILD ()
     OLD_MAKE=$MAKE
   fi
 
-  if [[ -n "$TESTS_ENVIRONMENT" ]]; then
-    OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
+  if [[ -n "$LOG_COMPILER" ]]; then
+    OLD_LOG_COMPILER=$LOG_COMPILER
   fi
 }
 
-function restore_BUILD ()
+restore_BUILD ()
 {
   if [[ -n "$OLD_CONFIGURE" ]]; then
     CONFIGURE=$OLD_CONFIGURE
@@ -402,100 +526,29 @@ function restore_BUILD ()
     CONFIGURE_ARG=$OLD_CONFIGURE_ARG
   fi
 
+  if [[ -n "$OLD_PREFIX" ]]; then
+    PREFIX_ARG=$OLD_PREFIX
+  fi
+
   if [[ -n "$OLD_MAKE" ]]; then
     MAKE=$OLD_MAKE
   fi
 
-  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
+  if [[ -n "$OLD_LOG_COMPILER" ]]; then
+    LOG_COMPILER=$OLD_LOG_COMPILER
   fi
 
   OLD_CONFIGURE=
   OLD_CONFIGURE_ARG=
+  OLD_PREFIX=
   OLD_MAKE=
-  OLD_TESTS_ENVIRONMENT=
+  OLD_LOG_COMPILER=
 
   export -n CC CXX
 }
 
-function push_PREFIX_ARG ()
-{
-  if [[ -n "$OLD_PREFIX_ARG" ]]; then
-    die "OLD_PREFIX_ARG was set on push, programmer error!"
-  fi
-
-  if [[ -n "$PREFIX_ARG" ]]; then
-    OLD_PREFIX_ARG=$PREFIX_ARG
-    PREFIX_ARG=
-  fi
-
-  if [[ -n "$1" ]]; then
-    PREFIX_ARG="--prefix=$1"
-  fi
-}
-
-function pop_PREFIX_ARG ()
-{
-  if [[ -n "$OLD_PREFIX_ARG" ]]; then
-    PREFIX_ARG=$OLD_PREFIX_ARG
-    OLD_PREFIX_ARG=
-  else
-    PREFIX_ARG=
-  fi
-}
-
-function push_TESTS_ENVIRONMENT ()
+make_valgrind ()
 {
-  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
-  fi
-
-  if [[ -n "$TESTS_ENVIRONMENT" ]]; then
-    OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
-    TESTS_ENVIRONMENT=
-  fi
-}
-
-function pop_TESTS_ENVIRONMENT ()
-{
-  TESTS_ENVIRONMENT=
-  if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
-    TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
-    OLD_TESTS_ENVIRONMENT=
-  fi
-}
-
-function safe_pushd ()
-{
-  pushd $1 &> /dev/null ;
-
-  if [ -n "$BUILD_DIR" ]; then
-    if $VERBOSE; then
-      echo "BUILD_DIR=$BUILD_DIR"
-    fi
-  fi
-}
-
-function safe_popd ()
-{
-  local directory_to_delete=`pwd`
-  popd &> /dev/null ;
-  if [ $? -eq 0 ]; then
-    if [[ "$top_srcdir" == "$directory_to_delete" ]]; then
-      die "We almost deleted top_srcdir($top_srcdir), programmer error"
-    fi
-
-    rm -r -f "$directory_to_delete"
-  fi
-}
-
-function make_valgrind ()
-{
-  if [[ "$VENDOR_DISTRIBUTION" == 'darwin' ]]; then
-    make_darwin_malloc
-    return
-  fi
-
   # If the env VALGRIND_COMMAND is set then we assume it is valid
   local valgrind_was_set=false
   if [[ -z "$VALGRIND_COMMAND" ]]; then
@@ -513,28 +566,40 @@ function make_valgrind ()
     return 1
   fi
 
-  # If we are required to run configure, do so now
-  run_configure_if_required
+  save_BUILD
+
+  valgrind_run=true
 
-  push_TESTS_ENVIRONMENT
+  # If we are required to run configure, do so now
+  run_configure
 
   # If we don't have a configure, then most likely we will be missing libtool
   assert_file 'configure'
-  if [[ -f 'libtool' ]]; then
-    TESTS_ENVIRONMENT="./libtool --mode=execute $VALGRIND_COMMAND"
+  if [[ -x 'libtool' ]]; then
+    LOG_COMPILER="./libtool --mode=execute $VALGRIND_COMMAND"
   else
-    TESTS_ENVIRONMENT="$VALGRIND_COMMAND"
+    LOG_COMPILER="$VALGRIND_COMMAND"
   fi
 
-  make_target 'check' || return 1
+  make_target 'all'
+  make_target 'check'
+  ret=$?
+
+  valgrind_run=false
+
+  restore_BUILD
 
-  pop_TESTS_ENVIRONMENT
+  if [ "$ret" -ne 0 ]; then
+    return 1
+  fi
 }
 
-function make_install_system ()
+make_install_system ()
 {
-  local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
-  push_PREFIX_ARG $INSTALL_LOCATION
+  local INSTALL_LOCATION="$(mktemp -d /tmp/XXXXXXXXXX)"
+
+  save_BUILD
+  PREFIX_ARG="--prefix=$INSTALL_LOCATION"
 
   if [ ! -d $INSTALL_LOCATION ] ; then
     die "ASSERT temp directory not found '$INSTALL_LOCATION'"
@@ -542,17 +607,12 @@ function make_install_system ()
 
   run_configure #install_buid_dir
 
-  push_TESTS_ENVIRONMENT
-
   make_target 'install'
 
   make_target 'installcheck'
 
   make_target 'uninstall'
 
-  pop_TESTS_ENVIRONMENT
-  pop_PREFIX_ARG
-
   rm -r -f $INSTALL_LOCATION
   make 'distclean'
 
@@ -560,10 +620,10 @@ function make_install_system ()
     die "ASSERT Makefile should not exist"
   fi
 
-  safe_popd
+  restore_BUILD
 }
 
-function make_darwin_malloc ()
+make_darwin_malloc ()
 {
   run_configure_if_required
 
@@ -581,35 +641,24 @@ function make_darwin_malloc ()
   MallocScribble=$old_MallocScribble
 }
 
-function snapshot_check ()
-{
-  if [ ! -f "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
-    make_for_snapshot
-  fi
-
-  if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
-    assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
-  fi
-}
-
 # This will reset our environment, and make sure built files are available.
-function make_for_snapshot ()
+make_for_snapshot ()
 {
-  # Make sure it is clean
-  make_maintainer_clean
+  # Lets make sure we have a clean environment
+  assert_no_file 'Makefile'
+  assert_no_file 'configure'
+  assert_no_directory 'autom4te.cache'
 
   run_configure
-  make_target 'dist'
+  make_target 'all'
   make_target 'distclean'
 
   # We should have a configure, but no Makefile at the end of this exercise
   assert_no_file 'Makefile'
   assert_exec_file 'configure'
-
-  snapshot_check
 }
 
-function check_mingw ()
+check_mingw ()
 {
   command_exists 'mingw64-configure'
   ret=$?
@@ -626,7 +675,7 @@ function check_mingw ()
   return 0
 }
 
-function check_clang ()
+check_clang ()
 {
   command_exists 'clang'
   ret=$?
@@ -637,7 +686,7 @@ function check_clang ()
   return 0
 }
 
-function check_clang_analyzer ()
+check_clang_analyzer ()
 {
   command_exists 'scan-build'
   ret=$?
@@ -648,7 +697,7 @@ function check_clang_analyzer ()
   return 0
 }
 
-function make_skeleton ()
+make_skeleton ()
 {
   run_configure
   ret=$?
@@ -663,11 +712,11 @@ function make_skeleton ()
     else
       if [[ -n "$DISPLAY" ]]; then
         if command_exists 'wine'; then
-          TESTS_ENVIRONMENT='wine'
+          LOG_COMPILER='wine'
         fi
       fi
 
-      if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+      if [[ -n "$LOG_COMPILER" ]]; then
         make_target 'check' 'warn' || warn "$MAKE check failed"
         ret=$?
       fi
@@ -681,7 +730,7 @@ function make_skeleton ()
   return $ret
 }
 
-function make_for_mingw ()
+make_for_mingw ()
 {
   if ! check_mingw; then
     return 1
@@ -708,7 +757,7 @@ function make_for_mingw ()
   return $ret
 }
 
-function make_for_clang ()
+make_for_clang ()
 {
   if ! check_clang; then
     return 1
@@ -736,7 +785,7 @@ function make_for_clang ()
   return $ret
 }
 
-function make_for_clang_analyzer ()
+make_for_clang_analyzer ()
 {
   if ! check_clang; then
     return 1
@@ -757,25 +806,21 @@ function make_for_clang_analyzer ()
 
   CC=clang CXX=clang++
   export CC CXX
+  CONFIGURE='scan-build ./configure'
   CONFIGURE_ARGS='--enable-debug'
 
-  make_skeleton
-  ret=$?
-
-  make_target 'clean' 'warn'
+  run_configure
 
   scan-build -o clang-html make -j4 -k
 
   restore_BUILD
-
-  return $ret
 }
 
 # If we are locally testing, we should make sure the environment is setup correctly
-function check_for_jenkins ()
+check_for_jenkins ()
 {
   if ! $jenkins_build_environment; then
-    echo "Not inside of jenkins"
+    echo "Not inside of jenkins, simulating environment"
 
     if [ -f 'configure' ]; then
       make_maintainer_clean
@@ -787,24 +832,50 @@ function check_for_jenkins ()
   fi
 }
 
-function make_universe ()
+make_universe ()
 {
+  use_banner 'make maintainer-clean'
+  make_maintainer_clean
+
+  use_banner 'snapshot'
   make_for_snapshot
+
+  use_banner 'valgrind'
   make_valgrind
+
+  use_banner 'gdb'
   make_gdb
+
+  use_banner 'rpm'
   make_rpm
+
+  use_banner 'clang'
   make_for_clang
+
+  use_banner 'clang analyzer'
   make_for_clang_analyzer
 
-  if [ check_mingw -eq 0 ]; then
+  use_banner 'mingw'
+  check_mingw
+  if [ $? -eq 0 ]; then
     make_for_mingw
   fi
 
+  use_banner 'make distcheck'
   make_distcheck
+
+  use_banner 'make install'
   make_install_system
 }
 
-function make_for_continuus_integration ()
+check_snapshot ()
+{
+  if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
+    assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
+  fi
+}
+
+make_for_continuus_integration ()
 {
   # Setup the environment if we are local
   check_for_jenkins
@@ -815,7 +886,11 @@ function make_for_continuus_integration ()
   # Platforms which require bootstrap should have some setup done before we hit this stage.
   # If we are building locally, skip this step, unless we are just testing locally. 
   if $BOOTSTRAP_SNAPSHOT; then
-    snapshot_check
+    if $BOOTSTRAP_SNAPSHOT; then
+      assert_file 'configure'
+    fi
+
+    check_snapshot
   else
     # If we didn't require a snapshot, then we should not have a configure
     assert_no_file 'configure'
@@ -826,71 +901,27 @@ function make_for_continuus_integration ()
   assert_no_file 'Makefile' 'Programmer error, Makefile existed where build state should have been clean'
 
   case $HOST_OS in
-    *-fedora-*)
-      run_configure
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_target 'all'
-
-      # make rpm includes "make distcheck"
-      if [[ -f rpm.am ]]; then
-        make_rpm
-      elif [[ -d rpm ]]; then
-        make_rpm
-      else
-        make_distcheck
-      fi
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_install_system
-      ;;
-    *-precise-*)
-      run_configure
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_target 'all'
-
-      make_distcheck
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_valgrind
-
-      assert_exec_file 'configure'
-      assert_file 'Makefile'
-
-      make_install_system
-      ;;
     *)
       make_jenkins_default
       ;;
   esac
 
   make_maintainer_clean
-
-  safe_popd
 }
 
 # The point to this test is to test bootstrap.sh itself
-function self_test ()
+self_test ()
 {
   # We start off with a clean env
   make_maintainer_clean
 
-  eval "./bootstrap.sh jenkins" || die "failed 'jenkins'"
-  eval "./bootstrap.sh all" || die "failed 'all'"
-  eval "./bootstrap.sh gdb" || die "failed 'gdb'"
-  eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
+#  eval "./bootstrap.sh jenkins" || die "failed 'jenkins'"
+#  eval "./bootstrap.sh all" || die "failed 'all'"
+#  eval "./bootstrap.sh gdb" || die "failed 'gdb'"
+#  eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
 }
 
-function make_install_html ()
+make_install_html ()
 {
   run_configure_if_required
   assert_file 'configure'
@@ -898,13 +929,13 @@ function make_install_html ()
   make_target 'install-html'
 }
 
-function make_gdb ()
+make_gdb ()
 {
+  save_BUILD
+
   if command_exists 'gdb'; then
     run_configure_if_required
 
-    push_TESTS_ENVIRONMENT
-
     # Set ENV GDB_COMMAND
     if [[ -z "$GDB_COMMAND" ]]; then
       setup_gdb_command
@@ -913,9 +944,9 @@ function make_gdb ()
     # If we don't have a configure, then most likely we will be missing libtool
     assert_file 'configure'
     if [[ -f 'libtool' ]]; then
-      TESTS_ENVIRONMENT="./libtool --mode=execute $GDB_COMMAND"
+      LOG_COMPILER="./libtool --mode=execute $GDB_COMMAND"
     else
-      TESTS_ENVIRONMENT="$GDB_COMMAND"
+      LOG_COMPILER="$GDB_COMMAND"
     fi
 
     make_target 'check'
@@ -924,8 +955,6 @@ function make_gdb ()
       rm 'gdb.txt'
     fi
 
-    pop_TESTS_ENVIRONMENT
-
     if [ -f '.gdb_history' ]; then
       rm '.gdb_history'
     fi
@@ -937,11 +966,13 @@ function make_gdb ()
     echo 'gdb was not present'
     return 1
   fi
+
+  restore_BUILD
 }
 
 # $1 target to compile
 # $2 to die, or not to die, based on contents
-function make_target ()
+make_target ()
 {
   if [ -z "$1" ]; then
     die "Programmer error, no target provided for make"
@@ -952,9 +983,9 @@ function make_target ()
     run_configure
   fi
 
-  if [ -n "$TESTS_ENVIRONMENT" ]; then
-    if $VERBOSE; then
-      echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
+  if [ -n "$LOG_COMPILER" ]; then
+    if $verbose; then
+      echo "LOG_COMPILER=$LOG_COMPILER"
     fi
   fi
 
@@ -963,12 +994,14 @@ function make_target ()
   fi
 
   # $2 represents error or warn
-  run $MAKE $1
+  run "$MAKE" "$1"
   ret=$?
 
   if [ $ret -ne 0 ]; then
     if [ -n "$2" ]; then
       warn "Failed to execute $MAKE $1: $ret"
+    elif [ $ret -eq 2 ]; then
+      die "Failed to execute $MAKE $1"
     else
       die "Failed to execute $MAKE $1: $ret"
     fi
@@ -977,27 +1010,32 @@ function make_target ()
   return $ret
 }
 
-function make_distcheck ()
+make_distcheck ()
 {
   make_target 'distcheck'
 }
 
-function make_rpm ()
+make_rpm ()
 {
   if command_exists 'rpmbuild'; then
     if [ -f 'rpm.am' -o -d 'rpm' ]; then
       run_configure_if_required
-      make_target 'rpm'
+      make_target 'dist-rpm'
 
       if $jenkins_build_environment; then
-        make_target 'clean'
+        mkdir artifacts
+        mv *.tar.gz *.rpm artifacts
+
+        make_target 'maintainer-clean'
+        mv artifacts/* .
+        rmdir artifacts
       fi
 
     fi
   fi
 }
 
-function make_maintainer_clean ()
+make_maintainer_clean ()
 {
   run_configure_if_required
   make_target 'maintainer-clean' 'no_error'
@@ -1008,24 +1046,34 @@ function make_maintainer_clean ()
   assert_no_directory 'autom4te.cache'
 }
 
-function make_check ()
+make_distclean ()
+{
+  run_configure_if_required
+  make_target 'distclean' 'no_error'
+
+  # Lets make sure we really cleaned up the environment
+  assert_no_file 'Makefile'
+  assert_file 'configure'
+}
+
+make_check ()
 {
   make_target 'check'
 }
 
-function make_jenkins_default ()
+make_jenkins_default ()
 {
   run_configure
   make_target 'all'
 }
 
-function make_default ()
+make_default ()
 {
   run_configure_if_required
   make_target 'all'
 }
 
-function run_configure_if_required () 
+run_configure_if_required () 
 {
   run_autoreconf_if_required
 
@@ -1036,34 +1084,46 @@ function run_configure_if_required ()
   assert_file 'Makefile' 'configure did not produce a Makefile'
 }
 
-function run_autoreconf_if_required () 
+run_make_maintainer_clean_if_possible () 
+{
+  if [ -f 'Makefile' ]; then
+    make_maintainer_clean
+  fi
+}
+
+run_autoreconf_if_required () 
 {
   if [ ! -x 'configure' ]; then
     run_autoreconf
   fi
 
   assert_exec_file 'configure'
+  bash -n configure
 }
 
-function run_autoreconf () 
+run_autoreconf () 
 {
   if [[ -z "$AUTORECONF" ]]; then
     die "Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
   fi
 
-  if test $use_libtool = 1; then
+  if $use_libtool; then
     assert $BOOTSTRAP_LIBTOOLIZE
-    run $BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
+    if $jenkins_build_environment; then
+      run "$BOOTSTRAP_LIBTOOLIZE" '--copy' '--install' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
+    else
+      run "$BOOTSTRAP_LIBTOOLIZE" '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
+    fi
   fi
 
-  run $AUTORECONF || die "Cannot execute $AUTORECONF"
+  run "$AUTORECONF" "$AUTORECONF_ARGS" || die "Cannot execute $AUTORECONF"
 
   eval 'bash -n configure' || die "autoreconf generated a malformed configure"
 }
 
-function run ()
+run ()
 {
-  if $VERBOSE; then
+  if $verbose; then
     echo "\`$@' $ARGS"
   fi
 
@@ -1071,48 +1131,59 @@ function run ()
     return 127;
   fi
 
-  eval $@ $ARGS
+  eval "$@" "$ARGS"
 } 
 
-function parse_command_line_options ()
+parse_command_line_options ()
 {
   local SHORTOPTS=':apcmt:dvh'
 
-  nassert MAKE_TARGET
+  nassert OPT_TARGET
 
   while getopts "$SHORTOPTS" opt; do
     case $opt in
       a) #--autoreconf
         AUTORECONF_OPTION=true
-        MAKE_TARGET='autoreconf'
+        OPT_TARGET+='autoreconf'
         ;;
       p) #--print-env
-        PRINT_SETUP_OPTION=true
+        print_setup_opt=true
         ;;
       c) # --configure
         CONFIGURE_OPTION=true
-        MAKE_TARGET='configure'
+        OPT_TARGET+='configure'
         ;;
       m) # maintainer-clean
         CLEAN_OPTION=true
-        MAKE_TARGET='clean_op'
+        ;;
+      o) # target
+        CONFIGURE_ARG="$OPTARG"
         ;;
       t) # target
         TARGET_OPTION=true
         TARGET_OPTION_ARG="$OPTARG"
-        MAKE_TARGET="$OPTARG"
+        OPT_TARGET+="$OPTARG"
         ;;
       d) # debug
-        DEBUG_OPTION=true
+        opt_debug=true
         enable_debug
         ;;
       h) # help
         echo "bootstrap.sh [options] optional_target ..."
+        echo "  -a # Just run autoreconf";
+        echo "  -p # Print ENV";
+        echo "  -c # Just run configure";
+        echo "  -m # Just run maintainer-clean";
+        echo "  -o # Specify configure arguments";
+        echo "  -t # Make target";
+        echo "  -d # Enable debug";
+        echo "  -h # Show help";
+        echo "  -v # Be more verbose in output";
         exit
         ;;
       v) # verbose
-        VERBOSE_OPTION=true
-        VERBOSE=true
+        opt_verbose=true
+        verbose=true
         ;;
       :)
         echo "Option -$OPTARG requires an argument." >&2
@@ -1128,11 +1199,11 @@ function parse_command_line_options ()
   shift $((OPTIND-1))
 
   if [ -n "$1" ]; then
-    MAKE_TARGET="$@"
+    OPT_TARGET="$@"
   fi
 }
 
-function determine_vcs ()
+determine_vcs ()
 {
   if [[ -d '.git' ]]; then
     VCS_CHECKOUT=git
@@ -1142,50 +1213,55 @@ function determine_vcs ()
     VCS_CHECKOUT=svn
   elif [[ -d '.hg' ]]; then
     VCS_CHECKOUT=hg
+  else
+    VCS_CHECKOUT=
   fi
 
   if [[ -n "$VCS_CHECKOUT" ]]; then
-    VERBOSE=true
+    verbose=true
   fi
 }
 
-function require_libtoolise ()
+require_libtoolise ()
 {
-  use_libtool=0
   grep '^[         ]*A[CM]_PROG_LIBTOOL' configure.ac >/dev/null \
-    && use_libtool=1
+    && use_libtool=true
   grep '^[         ]*LT_INIT' configure.ac >/dev/null \
-    && use_libtool=1
+    && use_libtool=true
 }
 
-function autoreconf_setup ()
+autoreconf_setup ()
 {
   # Set ENV MAKE in order to override "make"
   if [[ -z "$MAKE" ]]; then 
     if command_exists 'gmake'; then
-      MAKE=`type -p gmake`
+      MAKE="$(type -p gmake)"
     else
       if command_exists 'make'; then
-        MAKE=`type -p make`
+        MAKE="$(type -p make)"
       fi
     fi
     
     if [ "$VCS_CHECKOUT" ]; then
-      if $DEBUG; then
+      if $debug; then
         MAKE="$MAKE --warn-undefined-variables"
       fi
     fi
 
-    if $DEBUG; then
+    if $debug; then
       MAKE="$MAKE -d"
     fi
   fi
 
   if [[ -z "$GNU_BUILD_FLAGS" ]]; then
-    GNU_BUILD_FLAGS="--install --force"
+    if $jenkins_build_environment; then
+      GNU_BUILD_FLAGS="--install"
+    else
+      GNU_BUILD_FLAGS="--install --force"
+    fi
   fi
 
-  if $VERBOSE; then
+  if $verbose; then
     GNU_BUILD_FLAGS="$GNU_BUILD_FLAGS --verbose"
   fi
 
@@ -1201,83 +1277,90 @@ function autoreconf_setup ()
     fi
   fi
 
-  if test $use_libtool = 1; then
+  if $use_libtool; then
     if [[ -n "$LIBTOOLIZE" ]]; then
-      BOOTSTRAP_LIBTOOLIZE=`type -p $LIBTOOLIZE`
+      BOOTSTRAP_LIBTOOLIZE="$(type -p $LIBTOOLIZE)"
 
       if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
         echo "Couldn't find user supplied libtoolize, it is required"
+        return 1
       fi
     else
       # If we are using OSX, we first check to see glibtoolize is available
       if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
-        BOOTSTRAP_LIBTOOLIZE=`type -p glibtoolize`
+        BOOTSTRAP_LIBTOOLIZE="$(type -p glibtoolize)"
 
         if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
           echo "Couldn't find glibtoolize, it is required on OSX"
+          return 1
         fi
       else
-        BOOTSTRAP_LIBTOOLIZE=`type -p libtoolize`
+        BOOTSTRAP_LIBTOOLIZE="$(type -p libtoolize)"
 
         if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
           echo "Couldn't find libtoolize, it is required"
+          return 1
         fi
       fi
     fi
-    if $VERBOSE; then
+
+    if $verbose; then
       LIBTOOLIZE_OPTIONS="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
     fi
-    if $DEBUG; then
+
+    if $debug; then
       LIBTOOLIZE_OPTIONS="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
     fi
+
+    # Here we set LIBTOOLIZE to true since we are going to invoke it via BOOTSTRAP_LIBTOOLIZE
     LIBTOOLIZE=true
   fi
 
   # Test the ENV AUTOMAKE if it exists
   if [[ -n "$AUTOMAKE" ]]; then
-    run $AUTOMAKE '--help'    &> /dev/null    || die "Failed to run AUTOMAKE:$AUTOMAKE"
+    run "$AUTOMAKE" '--help'    &> /dev/null    || die "Failed to run AUTOMAKE:$AUTOMAKE"
   fi
 
   # Test the ENV AUTOCONF if it exists
   if [[ -n "$AUTOCONF" ]]; then
-    run $AUTOCONF '--help'    &> /dev/null    || die "Failed to run AUTOCONF:$AUTOCONF"
+    run "$AUTOCONF" '--help'    &> /dev/null    || die "Failed to run AUTOCONF:$AUTOCONF"
   fi
 
   # Test the ENV AUTOHEADER if it exists
   if [[ -n "$AUTOHEADER" ]]; then
-    run $AUTOHEADER '--help'  &> /dev/null    || die "Failed to run AUTOHEADER:$AUTOHEADER"
+    run "$AUTOHEADER" '--help'  &> /dev/null    || die "Failed to run AUTOHEADER:$AUTOHEADER"
   fi
 
   # Test the ENV AUTOM4TE if it exists
   if [[ -n "$AUTOM4TE" ]]; then
-    run $AUTOM4TE '--help'    &> /dev/null    || die "Failed to run AUTOM4TE:$AUTOM4TE"
+    run "$AUTOM4TE" '--help'    &> /dev/null    || die "Failed to run AUTOM4TE:$AUTOM4TE"
   fi
 
   # Test the ENV AUTOHEADER if it exists, if not we add one and add --install
   if [[ -z "$ACLOCAL" ]]; then
     ACLOCAL="aclocal --install"
   fi
-  run $ACLOCAL '--help'  &> /dev/null    || die "Failed to run ACLOCAL:$ACLOCAL"
+  run "$ACLOCAL" '--help'  &> /dev/null    || die "Failed to run ACLOCAL:$ACLOCAL"
 
   if [[ -z "$AUTORECONF" ]]; then
-    AUTORECONF=`type -p autoreconf`
+    AUTORECONF="$(type -p autoreconf)"
 
     if [[ -z "$AUTORECONF" ]]; then
       die "Couldn't find autoreconf"
     fi
 
     if [[ -n "$GNU_BUILD_FLAGS" ]]; then
-      AUTORECONF="$AUTORECONF $GNU_BUILD_FLAGS"
+      AUTORECONF_ARGS="$GNU_BUILD_FLAGS"
     fi
   fi
 
-  run $AUTORECONF '--help'  &> /dev/null    || die "Failed to run AUTORECONF:$AUTORECONF"
+  run "$AUTORECONF" '--help'  &> /dev/null    || die "Failed to run AUTORECONF:$AUTORECONF"
 }
 
-function print_setup ()
+print_setup ()
 {
-  saved_debug_status=$DEBUG
-  if $DEBUG; then
+  local saved_debug_status=$debug
+  if $debug; then
     disable_debug
   fi
 
@@ -1285,6 +1368,9 @@ function print_setup ()
   echo 'BOOTSTRAP ENV' 
   echo "AUTORECONF=$AUTORECONF"
   echo "HOST_OS=$HOST_OS"
+  echo "VENDOR=$VENDOR"
+  echo "VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
+  echo "VENDOR_RELEASE=$VENDOR_RELEASE"
 
   echo "getopt()"
   if $AUTORECONF_OPTION; then
@@ -1299,11 +1385,11 @@ function print_setup ()
     echo "--configure"
   fi
 
-  if $DEBUG_OPTION; then
+  if $opt_debug; then
     echo "--debug"
   fi
 
-  if $PRINT_SETUP_OPTION; then
+  if $print_setup_opt; then
     echo "--print-env"
   fi
 
@@ -1311,7 +1397,7 @@ function print_setup ()
     echo "--target=$TARGET_OPTION_ARG"
   fi
 
-  if $VERBOSE_OPTION; then
+  if $opt_verbose; then
     echo "--verbose"
   fi
 
@@ -1319,33 +1405,34 @@ function print_setup ()
     echo "MAKE=$MAKE"
   fi
 
-  if [[ -n "$MAKE_TARGET" ]]; then
-    echo "MAKE_TARGET=$MAKE_TARGET"
+  if [[ -n "$BOOTSTRAP_TARGET" ]]; then
+    echo "BOOTSTRAP_TARGET=$BOOTSTRAP_TARGET"
   fi
 
   if [[ -n "$PREFIX" ]]; then
     echo "PREFIX=$PREFIX"
   fi
 
-  if [[ -n "$TESTS_ENVIRONMENT" ]]; then
-    echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
+  if [[ -n "$LOG_COMPILER" ]]; then
+    echo "LOG_COMPILER=$LOG_COMPILER"
   fi
 
   if [[ -n "$VCS_CHECKOUT" ]]; then
     echo "VCS_CHECKOUT=$VCS_CHECKOUT"
   fi
 
-  if $VERBOSE; then
-    echo "VERBOSE=true"
-  fi
-
-  if $DEBUG; then
-    echo "DEBUG=true"
+  if $debug; then
+    echo "debug=true"
   fi
 
   if [[ -n "$WARNINGS" ]]; then
     echo "WARNINGS=$WARNINGS"
   fi
+
+  if $saved_debug_status; then
+    echo "DEBUG=true"
+  fi
+
   echo '----------------------------------------------' 
 
   if $saved_debug_status; then
@@ -1353,7 +1440,7 @@ function print_setup ()
   fi
 }
 
-function make_clean_option ()
+make_clean_option ()
 {
   run_configure_if_required
 
@@ -1366,7 +1453,7 @@ function make_clean_option ()
   fi
 }
 
-function make_for_autoreconf ()
+make_for_autoreconf ()
 {
   if [ -f 'Makefile' ]; then
     make_maintainer_clean
@@ -1377,8 +1464,9 @@ function make_for_autoreconf ()
   assert_no_file 'Makefile'
 }
 
-function check_make_target()
+check_make_target()
 {
+  local ret=0
   case $1 in
     'self')
       ;;
@@ -1422,65 +1510,84 @@ function check_make_target()
       ;;
     'clang-analyzer')
       ;;
-    'test-*')
+    test-*)
       ;;
-    'valgrind-*')
+    valgrind-*)
       ;;
-    'gdb-*')
+    gdb-*)
       ;;
     'dist')
       ;;
     *)
-      die "Unknown MAKE_TARGET option: $1"
+      echo "Matched default"
+      ret=1
       ;;
   esac
+
+  return $ret
 }
 
-function bootstrap ()
+execute_job ()
 {
+  # We should always have a target by this point
+  assert BOOTSTRAP_TARGET
+
   determine_target_platform
 
   determine_vcs
 
   # Set up whatever we need to do to use autoreconf later
+  use_libtool=false
   require_libtoolise
-  autoreconf_setup
-
-  if [ -z "$MAKE_TARGET" ]; then
-    MAKE_TARGET="make_default"
+  if ! autoreconf_setup; then
+    return 1
   fi
 
-  if $PRINT_SETUP_OPTION -o  $DEBUG; then
+  if $print_setup_opt -o  $debug; then
     echo 
     print_setup
     echo 
 
     # Exit if all we were looking for were the currently used options
-    if $PRINT_SETUP_OPTION; then
+    if $print_setup_opt; then
       exit
     fi
   fi
 
-  # Use OLD_TESTS_ENVIRONMENT for tracking the state of the variable
-  local OLD_TESTS_ENVIRONMENT=
+  # Use OLD_LOG_COMPILER for tracking the state of the variable
+  local OLD_LOG_COMPILER=
 
   # Set ENV PREFIX in order to set --prefix for ./configure
   if [[ -n "$PREFIX" ]]; then 
-    push_PREFIX_ARG $PREFIX
+    PREFIX_ARG="--prefix=$PREFIX"
   fi
 
-  # We should always have a target by this point
-  assert MAKE_TARGET
+  if $CLEAN_OPTION; then
+    make_maintainer_clean
+  fi
 
-  local MAKE_TARGET_ARRAY=($MAKE_TARGET)
+  local BOOTSTRAP_TARGET_ARRAY
+  BOOTSTRAP_TARGET_ARRAY=( $BOOTSTRAP_TARGET )
 
-  for target in "${MAKE_TARGET_ARRAY[@]}"
+  for target in "${BOOTSTRAP_TARGET_ARRAY[@]}"
   do
     # If we are running inside of Jenkins, we want to only run some of the possible tests
     if $jenkins_build_environment; then
       check_make_target $target
+      ret=$?
+      if [ $ret -ne 0 ]; then
+        warn "Unknown BOOTSTRAP_TARGET option: $target"
+        target="jenkins"
+      fi
     fi
 
+    if $jenkins_build_environment; then
+      use_banner $target
+    fi
+
+    local snapshot_run=false
+    local valgrind_run=false
+
     case $target in
       'self')
         self_test
@@ -1507,6 +1614,7 @@ function bootstrap ()
         make_default
         ;;
       'clang')
+        make_distclean
         if ! check_clang; then
           die "clang was not found"
         fi
@@ -1516,6 +1624,7 @@ function bootstrap ()
         fi
         ;;
       'clang-analyzer')
+        make_distclean
         if ! check_clang_analyzer; then
           die "clang-analyzer was not found"
         fi
@@ -1528,20 +1637,22 @@ function bootstrap ()
         fi
         ;;
       'mingw')
-        if ! check_mingw; then
-          die "mingw was not found"
-        fi
-
+        make_distclean
         if ! make_for_mingw; then
           die "Failed to build mingw: $?"
         fi
         ;;
       'snapshot')
         make_for_snapshot
+        snapshot_run=true
+        check_snapshot
         ;;
       'rpm')
         make_rpm
         ;;
+      'darwin_malloc')
+        make_darwin_malloc
+        ;;
       'valgrind')
         make_valgrind
         ;;
@@ -1559,35 +1670,51 @@ function bootstrap ()
   done
 }
 
-function main ()
+main ()
 {
+  # Are we running inside of Jenkins?
+  if [[ -n "$JENKINS_HOME" ]]; then 
+    declare -r jenkins_build_environment=true
+  else
+    declare -r jenkins_build_environment=false
+  fi
+
   # Variables we export
   declare -x VCS_CHECKOUT=
 
   # Variables we control globally
-  local MAKE_TARGET=
+  local -a BOOTSTRAP_TARGET=
   local CONFIGURE=
+  local use_libtool=false
+  local verbose=false
+
+  #getop variables
+  local opt_debug=false
+  local opt_verbose=false
+
+  if [[ -n "$VERBOSE" ]]; then
+    verbose=true
+  fi
 
   # Options for getopt
   local AUTORECONF_OPTION=false
   local CLEAN_OPTION=false
   local CONFIGURE_OPTION=false
-  local DEBUG_OPTION=false
-  local PRINT_SETUP_OPTION=false
+  local print_setup_opt=false
   local TARGET_OPTION=false
   local TARGET_OPTION_ARG=
-  local VERBOSE_OPTION=false
 
   local OLD_CONFIGURE=
   local OLD_CONFIGURE_ARG=
+  local OLD_PREFIX=
   local OLD_MAKE=
-  local OLD_TESTS_ENVIRONMENT=
+  local OLD_LOG_COMPILER=
 
   # If we call autoreconf on the platform or not
   local AUTORECONF_REBUILD_HOST=false
   local AUTORECONF_REBUILD=false
 
-  local -r top_srcdir=`pwd`
+  local -r top_srcdir="$(pwd)"
 
   # Default configure
   if [ -z "$CONFIGURE" ]; then
@@ -1616,26 +1743,32 @@ function main ()
 
   rebuild_host_os no_output
 
-  parse_command_line_options $@
+  local OPT_TARGET=
+  parse_command_line_options "$@"
 
-  # If we are running under Jenkins we predetermine what tests we will run against
-  # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
-  # We don't want Jenkins overriding other variables, so we NULL them.
-  if [ -z "$MAKE_TARGET" ]; then
-    if $jenkins_build_environment; then
-      MAKE_TARGET='jenkins'
-    fi
+  nassert BOOTSTRAP_TARGET
+
+  if [ -n "$OPT_TARGET" ]; then
+    BOOTSTRAP_TARGET="$OPT_TARGET"
   fi
 
-  bootstrap
+  if [ -z "$BOOTSTRAP_TARGET" ]; then
+    BOOTSTRAP_TARGET="make_default"
+  fi
+
+  # We should always have a target by this point
+  assert BOOTSTRAP_TARGET
+
+  execute_job
+  local ret=$?
 
   jobs -l
   wait
 
-  exit 0
+  exit $ret
 }
 
-function set_branch ()
+set_branch ()
 {
   if [ -z "$BRANCH" ]; then 
     if [ -z "$CI_PROJECT_TEAM" ]; then 
@@ -1657,7 +1790,7 @@ function set_branch ()
   fi
 }
 
-function merge ()
+merge ()
 {
   if [ -z "$VCS_CHECKOUT" ]; then
     die "Merges require VCS_CHECKOUT."
@@ -1677,21 +1810,21 @@ function merge ()
   fi
 }
 
-function enable_debug ()
+enable_debug ()
 {
-  if ! $DEBUG; then
-    local caller_loc=`caller`
-    if [ -n $1 ]; then
+  if ! $debug; then
+    local caller_loc="$(caller)"
+    if [[ -n "$1" ]]; then
       echo "$caller_loc Enabling debug: $1"
     else
       echo "$caller_loc Enabling debug"
     fi
     set -x
-    DEBUG=true
+    debug=true
   fi
 }
 
-function usage ()
+usage ()
 {
   cat << EOF
   Usage: $program_name [OPTION]..
@@ -1703,74 +1836,83 @@ function usage ()
 EOF
 }
 
-function disable_debug ()
+disable_debug ()
 {
   set +x
-  DEBUG=true
+  debug=false
 }
 
-# Script begins here
+check_shell ()
+{
+  if [ -x '/usr/local/bin/shellcheck' ]; then
+    /usr/local/bin/shellcheck "$1"
+    local ret=$?
+
+    if [ "$ret" -ne 0 ]; then
+      die "$1 failed shellcheck"
+    fi
+  fi
+}
+
+bootstrap ()
+{
+  check_shell 'bootstrap.sh'
+  local env_debug_enabled=false
+  local debug=false
+
+  export ACLOCAL
+  export AUTOCONF
+  export AUTOHEADER
+  export AUTOM4TE
+  export AUTOMAKE
+  export AUTORECONF
+  export CONFIGURE_ARG
+  export DEBUG
+  export GNU_BUILD_FLAGS
+  export LIBTOOLIZE
+  export LIBTOOLIZE_OPTIONS
+  export MAKE
+  export PREFIX_ARG
+  export LOG_COMPILER
+  export VERBOSE
+  export WARNINGS
+
+  case $OSTYPE in
+    darwin*)
+      export MallocGuardEdges
+      export MallocErrorAbort
+      export MallocScribble
+      ;;
+  esac
 
-program_name=$0
-
-env_debug_enabled=false
-if [[ -n "$JENKINS_HOME" ]]; then 
-  declare -r jenkins_build_environment=true
-else
-  declare -r jenkins_build_environment=false
-fi
-
-export ACLOCAL
-export AUTOCONF
-export AUTOHEADER
-export AUTOM4TE
-export AUTOMAKE
-export AUTORECONF
-export DEBUG
-export GNU_BUILD_FLAGS
-export LIBTOOLIZE
-export LIBTOOLIZE_OPTIONS
-export MAKE
-export TESTS_ENVIRONMENT
-export VERBOSE
-export WARNINGS
-
-case $OSTYPE in
-  darwin*)
-    export MallocGuardEdges
-    export MallocErrorAbort
-    export MallocScribble
-    ;;
-esac
-
-# We check for DEBUG twice, once before we source the config file, and once afterward
-env_debug_enabled=false
-if [[ -n "$DEBUG" ]]; then
-  env_debug_enabled=true
-  enable_debug
-  print_setup
-fi
-
-# Variables which only can be set by .bootstrap
-BOOTSTRAP_SNAPSHOT=false
-BOOTSTRAP_SNAPSHOT_CHECK=
-
-if [ -f '.bootstrap' ]; then
-  source '.bootstrap'
-fi
-
-if $env_debug_enabled; then
-  enable_debug
-else
+  # We check for DEBUG twice, once before we source the config file, and once afterward
   if [[ -n "$DEBUG" ]]; then
+    env_debug_enabled=true
+  fi
+
+  # Variables which only can be set by .bootstrap
+  BOOTSTRAP_SNAPSHOT=false
+  BOOTSTRAP_SNAPSHOT_CHECK=
+
+  if [ -f '.bootstrap' ]; then
+    source '.bootstrap'
+  fi
+
+  # We do this in order to protect the case where DEBUG that came from the ENV (i.e. it overrides what is found in .bootstrap
+  if $env_debug_enabled; then
+    enable_debug
+  elif [[ -n "$DEBUG" ]]; then
     enable_debug "Enabling DEBUG from '.bootstrap'"
+  fi
+
+  if $env_debug_enabled; then
     print_setup
   fi
-fi
 
-# We do this in order to protect the case where DEBUG
-if ! $env_debug_enabled; then
-  DEBUG=false
-fi
 
-main $@
+  main "$@"
+}
+
+# Script begins here
+declare -r program_name="$0"
+bootstrap "$@"